=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2005-09-10 19:44:52 +0000
+++ bzrlib/graph.py	2005-09-10 22:55:35 +0000
@@ -153,6 +153,9 @@
     if node in distances:
         best = distances[node]
     for ancestor in ancestors[node]:
+        if ancestor not in ancestors:
+            print ancestor
+            continue
         if ancestor not in distances:
             return None
         if best is None or distances[ancestor] > best:
@@ -161,6 +164,7 @@
 
     
 def farthest_node(graph, ancestors, start):
+    assert 'A' in graph
     distances = {start: 0}
     lines = set([start])
     while len(lines) > 0:
@@ -179,6 +183,4 @@
         return distances[n]
     node_list = distances.keys()
     node_list.sort(key=by_distance, reverse=True)
-    assert len(node_list) == len(graph), "%d nodes missing" % \
-        (len(graph) - len(node_list)) 
     return node_list

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-09-10 19:45:35 +0000
+++ bzrlib/revision.py	2005-09-10 22:55:35 +0000
@@ -274,14 +274,16 @@
                 if len(parents) == 0:
                     root = line
             except bzrlib.errors.NoSuchRevision:
-                parents = []
-            for parent in parents:
-                if parent not in ancestors:
-                    new_lines.add(parent)
-                if parent not in descendants:
-                    descendants[parent] = {}
-                descendants[parent][line] = 1
-            ancestors[line] = set(parents)
+                parents = None
+            if parents is not None:
+                for parent in parents:
+                    if parent not in ancestors:
+                        new_lines.add(parent)
+                    if parent not in descendants:
+                        descendants[parent] = {}
+                    descendants[parent][line] = 1
+            if parents is not None:
+                ancestors[line] = set(parents)
         lines = new_lines
     assert root not in descendants[root]
     assert root not in ancestors[root]

=== modified file 'bzrlib/selftest/testgraph.py'
--- bzrlib/selftest/testgraph.py	2005-09-06 04:14:01 +0000
+++ bzrlib/selftest/testgraph.py	2005-09-10 22:55:35 +0000
@@ -34,7 +34,8 @@
         self.edge_add('A', 'E', 'F', 'C')
         self.edge_add('A', 'G', 'H', 'I', 'B')
         self.edge_add('A', 'J', 'K', 'L', 'M', 'N')
-        descendants = {}
+        self.edge_add('O', 'N')
+        descendants = {'A':set()}
         for node in self.graph:
             for ancestor in self.graph[node]:
                 if ancestor not in descendants:

